import { jsx as e } from "react/jsx-runtime";
import c from "react";
import { a as s } from "../../../react.esm-GKFzux-6.mjs";
import "../../../index-6HDrCuH_.mjs";
import n from "../BoundedOverlayManagerContent.js";
import { useOverlayManagerContext as v } from "../../context/OverlayManagerContext.js";
import d from "../../hooks/useTimedEventManager.js";
import u from "../../hooks/useForwardBoundingComponentEvents.js";
import h from "../../hooks/useOverlayManagerEvents.js";
import m from "../../hooks/useResizeObserver.js";
import { makeEventOnlyMockComponentRef as p } from "../../hooks/test/util.js";
import O from "../../hooks/useApiUpdateHandler.js";
jest.mock("../../hooks/useTimedEventManager");
jest.mock("../../hooks/useForwardBoundingComponentEvents");
jest.mock("../../hooks/useOverlayManagerEvents");
jest.mock("../../hooks/useResizeObserver");
jest.mock("../../hooks/useApiUpdateHandler");
jest.mock("../../util/bbox", () => ({ copyComponentBoundingBox: jest.fn() }));
jest.mock("../OverlaysContainer", () => c.forwardRef(({ children: a, show: t }, r) => /* @__PURE__ */ e("div", { ref: r, "data-testid": "overlays-container", "data-show": t, children: a })));
jest.mock("../../context/OverlayManagerContext");
describe("BoundedOverlayManagerContent", () => {
  let a;
  beforeEach(() => {
    a = p(), v.mockReturnValue({
      boundingComponentRef: a
    });
  }), afterEach(() => {
    jest.clearAllMocks();
  }), it("calls useTimedEventManager with the correct arguments", () => {
    s(
      /* @__PURE__ */ e(n, { children: /* @__PURE__ */ e("div", { children: "Mock Children" }) })
    ), expect(d).toHaveBeenCalledWith(expect.objectContaining({
      onStart: expect.any(Function),
      onStop: expect.any(Function),
      timeoutDuration: 2e3,
      returnNull: !1
    }));
  }), it("calls useForwardBoundingComponentEvents", () => {
    s(
      /* @__PURE__ */ e(n, { children: /* @__PURE__ */ e("div", { children: "Mock Children" }) })
    ), expect(u).toHaveBeenCalled();
  }), it.each([
    {
      showOverlaysOnMouseMove: !0,
      hideOverlaysOnMouseLeave: !1,
      skipAllSystemEvents: !1
    },
    {
      showOverlaysOnMouseMove: !1,
      hideOverlaysOnMouseLeave: !0,
      skipAllSystemEvents: !1
    },
    {
      showOverlaysOnMouseMove: !0,
      hideOverlaysOnMouseLeave: !0,
      skipAllSystemEvents: !0
    },
    {
      showOverlaysOnMouseMove: !1,
      hideOverlaysOnMouseLeave: !1,
      skipAllSystemEvents: !0
    }
  ])("calls useOverlayManagerEvents with the correct arguments when showOverlaysOnMouseMove is $showOverlaysOnMouseMove, hideOverlaysOnMouseLeave is $hideOverlaysOnMouseLeave and skipAllSystemEvents is $skipAllSystemEvents", ({ showOverlaysOnMouseMove: t, hideOverlaysOnMouseLeave: r, skipAllSystemEvents: o }) => {
    const i = t && !o, l = r && !o;
    s(
      /* @__PURE__ */ e(n, { showOverlaysOnMouseMove: t, hideOverlaysOnMouseLeave: r, skipAllSystemEvents: o, children: /* @__PURE__ */ e("div", { children: "Mock Children" }) })
    ), expect(h).toHaveBeenCalledWith(expect.objectContaining({
      requestStartOnMouseMove: i,
      requestStopOnMouseMove: l
    }));
  }), it("calls useResizeObserver with the correct arguments", () => {
    s(
      /* @__PURE__ */ e(n, { children: /* @__PURE__ */ e("div", { children: "Mock Children" }) })
    ), expect(m).toHaveBeenCalledWith(a, expect.objectContaining({
      handleResize: expect.any(Function)
    }));
  }), it("renders OverlaysContainer with the correct props and children", () => {
    const { getByTestId: t, rerender: r } = s(
      /* @__PURE__ */ e(n, { persistentlyShowOverlays: !0, children: /* @__PURE__ */ e("div", { children: "Test Overlay" }) })
    ), o = t("overlays-container");
    expect(o).toHaveAttribute("data-show", "true"), expect(o).toHaveTextContent("Test Overlay"), r(
      /* @__PURE__ */ e(n, { persistentlyShowOverlays: !1, children: /* @__PURE__ */ e("div", { children: "Test Overlay" }) })
    ), expect(o).toHaveAttribute("data-show", "false");
  }), it("calls useApiUpdateHandler with the correct arguments", () => {
    const t = jest.fn();
    s(
      /* @__PURE__ */ e(n, { onApiUpdated: t, children: /* @__PURE__ */ e("div", { children: "Test Overlay" }) })
    ), expect(O).toHaveBeenCalledWith(expect.objectContaining({
      onApiUpdated: t
    }));
  });
});
