import { r as t, w as l } from "../../../react.esm-GKFzux-6.mjs";
import s from "../useWindowResize.js";
jest.mock("use-debounce", () => ({
  useDebouncedCallback: jest.fn((e) => e)
}));
describe("useWindowResize", () => {
  const e = jest.fn();
  let i, a;
  const o = (n) => {
    expect(i).toHaveBeenCalledWith("resize", n);
  }, r = (n) => {
    expect(a).toHaveBeenCalledWith("resize", n);
  };
  beforeEach(() => {
    i = jest.spyOn(window, "addEventListener"), a = jest.spyOn(window, "removeEventListener");
  }), afterEach(() => {
    jest.clearAllMocks();
  }), it("adds a debounced resize event listener", () => {
    t(() => s({ handleResize: e })), o(e);
  }), it("removes the resize event listener when unmounted", () => {
    const { unmount: n } = t(() => s({ handleResize: e }));
    n(), r(e);
  }), it("dees not update the resize event listener when handleResize does not change", async () => {
    const { rerender: n } = t(() => s({ handleResize: e }));
    i.mockClear(), n(), await l(() => {
      expect(i).not.toHaveBeenCalled(), expect(a).not.toHaveBeenCalled();
    });
  }), it("updates the resize event listener when handleResize changes", async () => {
    const { rerender: n } = t(({ handleResize: c }) => s({ handleResize: c }), {
      initialProps: { handleResize: e }
    }), d = jest.fn();
    n({ handleResize: d }), await l(() => {
      r(e), o(d);
    });
  }), it("calls handleResize on window resize", () => {
    t(() => s({ handleResize: e })), window.dispatchEvent(new Event("resize")), expect(e).toHaveBeenCalled();
  });
});
