import r, { NO_TIMEOUT as s } from "../TimedEventManager.js";
describe("TimedEventManager", () => {
  let a, t, e;
  const o = ({ onStart: i, onStop: l, timeoutDuration: n } = {}) => new r({
    onStart: i || a,
    onStop: l || t,
    timeoutDuration: n || 1e3
  });
  beforeEach(() => {
    a = jest.fn(), t = jest.fn(), e = o(), jest.useFakeTimers(), jest.spyOn(global, "setTimeout"), jest.spyOn(global, "clearTimeout");
  }), afterEach(() => {
    jest.useRealTimers(), jest.restoreAllMocks();
  }), it("should call onStart when requestStart is called", () => {
    e.requestStart(), expect(a).toHaveBeenCalled();
  }), it("should set a timeout and call onStop after the specified duration", () => {
    e.requestStart(), expect(setTimeout).toHaveBeenCalledWith(expect.any(Function), 1e3), expect(a).toHaveBeenCalled(), jest.advanceTimersByTime(1e3), expect(t).toHaveBeenCalled();
  }), it("should clear the timeout when requestStop is called", () => {
    e.requestStart(), e.requestStop(), expect(clearTimeout).toHaveBeenCalledWith(expect.any(Number)), jest.advanceTimersByTime(1e3), expect(t).toHaveBeenCalled();
  }), it("should handle NO_TIMEOUT case correctly", () => {
    e = o({ timeoutDuration: s }), e.requestStart(), expect(setTimeout).not.toHaveBeenCalled(), expect(a).toHaveBeenCalled(), e.requestStop(), expect(clearTimeout).not.toHaveBeenCalled(), expect(t).toHaveBeenCalled();
  }), it("should handle multiple requestStart calls before timeout clears", () => {
    e.requestStart(), jest.advanceTimersByTime(1e3 / 2), e.requestStart(), expect(setTimeout).toHaveBeenCalledTimes(2), expect(clearTimeout).toHaveBeenCalledTimes(1), expect(a).toHaveBeenCalledTimes(1), jest.advanceTimersByTime(1e3), expect(t).toHaveBeenCalledTimes(1);
  }), it("should not do anything on requestStop call without an active timeout", () => {
    e.requestStop(), expect(t).not.toHaveBeenCalled();
  });
});
